﻿using System;

namespace FirstProgram
{
  internal class MethodArguments
  {
    private void Foo(ref int p)
    {
      p = p + 1; // Increment p by 1
    }

    public void RefModifier()
    {
      int x = 8;
      Foo(ref x); // Ask Foo to deal directly with x
      Console.WriteLine(x); // x is now 9
    }

    private void Split(string name, out string firstNames, out string lastName)
    {
      int i = name.LastIndexOf(' ');
      firstNames = name.Substring(0, i);
      lastName = name.Substring(i + 1);
    }

    public void OutModifier()
    {
      string a, b;
      Split("Stevie Ray Vaughan", out a, out b);
      Console.WriteLine(a); // Stevie Ray
      Console.WriteLine(b); // Vaughan
    }

    static int Sum(params int[] ints)
    {
      int sum = 0;
      for (int i = 0; i < ints.Length; i++)
        sum += ints[i]; // Increase sum by ints[i]
      return sum;
    }

    public void ParamsModifier()
    {
      int total = Sum(1, 2, 3, 4);
      Console.WriteLine(total); // 10
    }


    void NamedArgumentsFoo(int x = 2, int y = 3)
    {
      Console.WriteLine(x + y);
    }

    public void NamedArguments()
    {
      int a = 0;
      NamedArgumentsFoo(y: 4, x: 4);
      NamedArgumentsFoo(y: ++a, x: --a);
    }
  }
}
